//Расчет результатов
function [datas,..//Данные
          datasHeaders..//Заголовки данных
          ]=CSVToDatas(DatasCSV,..//Входные данные
                       isDataHeaders,..//Заголовки входных данных
                       parseDatas..//Нужно или нет парсить данные
                       )
    //Проверяем аргументы
    nArg = argn(2);//Число аргументов
    if nArg < 1 then
        error('Function CSVToDatas takes 1, 2 or 3 arguments');
    end
    switch nArg
    case 1 then
        isDataHeaders = %f;
        parseDatas = %t;
    case 2 then
        parseDatas = %t;
    end
    if isempty(DatasCSV) || (type(DatasCSV) ~= 10) then
        error('The first argument of function CSVToDatas must be matrix of string (csv matrix)');
    end
    if (size(isDataHeaders,'*') ~= 1) || (type(isDataHeaders) ~= 4) then
        error('The isDataHeaders argument of function CSVToDatas must be boolen scalar');
    end
    if (size(parseDatas,'*') ~= 1) || (type(parseDatas) ~= 4) then
        error('The parseDatas argument of function CSVToDatas must be boolen scalar');
    end
    
    //Получаем данные и заголовок
    if isDataHeaders then
       datasHeaders = DatasCSV(1,:);//Берем заголовок
       DatasCSV(1,:) = [];//Убираем шапку
    else
       datasHeaders = [];//Заголовок пустой
    end
    if parseDatas then
        datas = evstr(DatasCSV);//Берем данные
    else
        datas = DatasCSV;//Берем данные
    end
endfunction
