//Расчет результатов
function [datasCSV]=DatasToCSV(Datas,..//Входные данные
                               DatasHeaders..//Заголовки входных данных
                               )
    //Проверяем аргументы
    nArg = argn(2);//Число аргументов
    if nArg < 1 then
        error('Function DatasToCSV takes 1 or 2 arguments');
    end
    if nArg == 1 then
        DatasHeaders = [];
    end
    if isempty(Datas) || (type(Datas) ~= 1) then
        error('The first argument of function DatasToCSV must be matrix of real');
    end
    if (~isempty(DatasHeaders)) && ((type(DatasHeaders) ~= 10) ||..
       (size(DatasHeaders)(1) > 1)) then
        error('The DatasHeaders argument of function DatasToCSV must be matrix 1xM of string');
    end
    
    //Формируем данные с заголовком в csv-формате
    datasCSV = [DatasHeaders; string(Datas)];
endfunction
