//Расчет результатов
function [rezults,..//Результаты расчета
          rezultsHeaders..//Заголовки результатов
          ]=CountRezults(inputDatas,..//Входные данные
                         inputDatasHeaders,..//Заголовки входных данных
                         Functions,..//Функции
                         argumentsNames,..//Имена (индексы) аргументов
                         rezultsNames,..//Имена (индексы) результатов
                         isVectorized..//Векторизованы ли функции
                         )
    //Проверяем аргументы
    [nOut,nArg] = argn();//Число аргументов
    if nArg < 4 then
        error('Function CountRezult takes 4, 5 or 6 arguments');
    end
    nIsVectorized = size(Functions,'*');
    switch nArg
    case 4 then
        rezultsNames = argumentsNames;
        argumentsNames = Functions;
        Functions = inputDatasHeaders;
        inputDatasHeaders = [];
        isVectorized = repmat(%t,[1,nIsVectorized]);
    case 5 then
        if type(rezultsNames) == 4 then
            isVectorized = rezultsNames;
            rezultsNames = argumentsNames;
            argumentsNames = Functions;
            Functions = inputDatasHeaders;
            inputDatasHeaders = [];
        else
            isVectorized = repmat(%t,[1,nIsVectorized]);
        end
    end
    if isempty(inputDatas) || (type(inputDatas) ~= 1) then
        error('The first argument of function CountRezults must be matrix of real');
    end
    if (~isempty(inputDatasHeaders)) && (type(inputDatasHeaders) ~= 10) then
        error('The inputDatasHeaders argument of function CountRezults must be matrix 1xM of string');
    end
    if (type(isVectorized) ~= 4) || (size(isVectorized)(1) ~= 1) then
        error('The argument isVectorized of function CountRezults must be matrix 1xM of bool');
    end
    if size(isVectorized,'*') == 1 then
      isVectorized = repmat(isVectorized,[1,nIsVectorized]);
    end
    
    //Вычисляем значение функций
    rezults = [];
    if nOut >= 2 then
        rezultsHeaders = [];
    end
    for ind=1:size(Functions,'*')
        Arguments = SelectionDatas(inputDatasHeaders,..
                                   argumentsNames{ind},..
                                   inputDatas);
        if nOut >= 2 then
            rezultsHeaders = [rezultsHeaders,rezultsNames{ind}];
        end
        if isVectorized(ind) then
            rezult = Functions{ind}(Arguments);
        else
            rezult = [];
            nArguments = size(Arguments)(1);//Число аргусентов
            for indArg=1:nArguments
                rezult = [rezult;Functions{ind}(Arguments(indArg,:))];
            end
        end
        rezults = [rezults,rezult];
    end
endfunction
