//Расчет результатов
function [сoutputDatasRefErr,..//Относительные погрешности выходных данных
          сoutputDatasErr,..//Абсолютные погрешности выходных данных
          сoutputDatas,..//Рассчитанные выходные данные
          outputDatasHeaders,..//Заголовки рассчитанных выходных данных
          outputDatas,..//Рассчитанные выходные данные
          сoutputDatasRefErrMean,..//Среднее значение погрешности рассчитанных выходных данных
          сoutputDatasRefErrMax..//Максимальное значение погрешности рассчитанных выходных данных
          ]=CountRezultsRefErr(inputDatas,..//Входные данные
                               outputDatas,..//Выходные данные
                               inputDatasHeaders,..//Заголовки входных данных
                               outputDatasHeaders,..//Заголовки выходных данных
                               Functions,..//Функции
                               argumentsNames,..//Имена (индексы) аргументов
                               rezultsNames,..//Имена (индексы) результатов
                               isVectorized..//Векторизованы ли функции
                               )
    //Проверяем аргументы
    [nOut,nArg] = argn();//Число аргументов
    if nArg < 5 then
        error('Function CountRezultErr takes 5, 6, 7 or 8 arguments');
    end
    switch nArg
    case 5 then
        rezultsNames = Functions;
        argumentsNames = outputDatasHeaders;
        Functions = inputDatasHeaders;
        outputDatasHeaders = [];
        inputDatasHeaders = [];
        isVectorized = repmat(%t,[1,size(Functions,'*')]);
    case 6 then
        if type(argumentsNames) == 4 then
            isVectorized = argumentsNames;
            rezultsNames = Functions;
            argumentsNames = outputDatasHeaders;
            Functions = inputDatasHeaders;
            outputDatasHeaders = [];
            inputDatasHeaders = [];
        else
            rezultsNames = argumentsNames;
            argumentsNames = Functions;
            Functions = outputDatasHeaders;
            outputDatasHeaders = [];
            isVectorized = repmat(%t,[1,size(Functions,'*')]);
        end
    case 7 then
        if type(rezultsNames) == 4 then
            isVectorized = rezultsNames;
            rezultsNames = argumentsNames;
            argumentsNames = Functions;
            Functions = outputDatasHeaders;
            outputDatasHeaders = [];
        else
            isVectorized = repmat(%t,[1,size(Functions,'*')]);
        end
    end
    
    //Определяем выходные значения и абсолютные погрешности
    [сoutputDatasErr,..
     сoutputDatas,..
     outputDatasHeaders,..
     outputDatas] = CountRezultsErr(inputDatas,..//Входные данные
                                    outputDatas,..//Выходные данные
                                    inputDatasHeaders,..//Заголовки входных данных
                                    outputDatasHeaders,..//Заголовки выходных данных
                                    Functions,..//Функции
                                    argumentsNames,..//Имена (индексы) аргументов
                                    rezultsNames,..//Имена (индексы) результатов
                                    isVectorized..//Векторизованы ли функции
                                    );
                                
    //Определяем относительные погрешности
    сoutputDatasRefErr = сoutputDatasErr * 100 ./ abs(outputDatas);
    
    //Рассчитываем среднее и максимальное значения относительной погрешности
    if nOut >= 6 then
        сoutputDatasRefErrMean = mean(сoutputDatasRefErr,'r');
    end
    if nOut >= 7 then
        сoutputDatasRefErrMax = max(сoutputDatasRefErr,'r');
    end
endfunction
