//Расчет результатов
function [datas,..//Данные
          datasHeaders..//Заголовки данных
          ]=CSVFromFileToDatas(isDataHeaders,..//Заголовки входных данных
                               CSVFileName,..//Имя csv-файла
                               CSVFileSep,..//Сепаратор csv-файла
                               CSVFileDec,..//Десятичный разделитель CSV-файла
                               parseDatas..//Нужно или нет парсить данные
                               )
    //Проверяем аргументы
    nArg = argn(2);//Число аргументов
    if nArg < 1 then
        error('Function DatasToCSVFile takes 1, 2, 3, 4 or 5 arguments');
    end
    switch nArg
    case 1 then
      CSVFileName = isDataHeaders; 
      isDataHeaders = %f;
      CSVFileSep = ',';
      CSVFileDec = '.';
      parseDatas = %t;
    case 2 then
      if type(isDataHeaders) == 4 then
        CSVFileSep = ',';
      else
        CSVFileSep = CSVFileName;
        CSVFileName = isDataHeaders;
        isDataHeaders = %f;
      end
      CSVFileDec = '.';
      parseDatas = %t;
    case 3 then
      if type(isDataHeaders) == 4 then
        CSVFileDec = '.';
      else
        CSVFileDec = CSVFileSep;
        CSVFileSep = CSVFileName;
        CSVFileName = isDataHeaders;
        isDataHeaders = %f;
      end
      parseDatas = %t;
    case 4 then
      if type(isDataHeaders) == 4 then
        parseDatas = %t;
      else
        parseDatas = CSVFileDec;
        CSVFileDec = CSVFileSep;
        CSVFileSep = CSVFileName;
        CSVFileName = isDataHeaders;
        isDataHeaders = %f;
      end
    end
    if (size(isDataHeaders,'*') ~= 1) || (type(isDataHeaders) ~= 4) then
        error('The isDataHeaders argument of function DatasToCSVFile must be boolen scalar');
    end
    if (type(CSVFileName) ~= 10) || (size(CSVFileName,'*') > 1) then
        error('The CSVFileName argument of function DatasToCSVFile must be scalar string');
    end
    if (~isempty(CSVFileSep)) &&..
       ((type(CSVFileSep) ~= 10) || (size(CSVFileSep,'*') > 1)) then
        error('The CSVFileSep argument of function DatasToCSVFile must be scalar string');
    end
    if (~isempty(CSVFileDec)) &&..
       ((type(CSVFileDec) ~= 10) || (size(CSVFileDec,'*') > 1)) then
        error('The CSVFileDec argument of function DatasToCSVFile must be scalar string');
    end
    if (size(parseDatas,'*') ~= 1) || (type(parseDatas) ~= 4) then
        error('The parseDatas argument of function DatasToCSVFile must be boolen scalar');
    end
    
    //Считываем данные из файла
    DatasCSV = read_csv(CSVFileName,CSVFileSep);
    DatasCSV = strsubst(DatasCSV,CSVFileDec,'.');//Десятичный разделитель - точка
    
    //Получаем данные
    [datas,datasHeaders] = CSVToDatas(DatasCSV,isDataHeaders,..
                                      parseDatas);
endfunction
