 //Расчет результатов
function [datasCSV]=DatasToCSVFile(Datas,..//Входные данные
                                   DatasHeaders,..//Заголовки входных данных
                                   Rewrite,..//Необходимость перезаписи файла
                                   CSVFileName,..//Имя csv-файла
                                   CSVFileSep,..//Сепаратор csv-файла
                                   CSVFileDec..//Десятичный разделитель
                                   )
    //Проверяем аргументы
    nArg = argn(2);//Число аргументов
    if nArg < 2 then
        error('Function DatasToCSV takes 2, 3, 4, 5 or 6 arguments');
    end
    switch nArg
    case 2 then
        CSVFileName = DatasHeaders;
        Rewrite = %t;
        DatasHeaders = [];
        CSVFileSep = ',';
        CSVFileDec = '.';
    case 3 then
        CSVFileName = Rewrite;
        if type(DatasHeaders) == 4 then
            Rewrite = DatasHeaders;
            DatasHeaders = [];
        else
            Rewrite = %t;
        end
        CSVFileSep = ',';
        CSVFileDec = '.';
    case 4 then
        CSVFileSep = ',';
        CSVFileDec = '.';
    case 5 then
        CSVFileDec = '.';
    end
    if isempty(Datas) || (type(Datas) ~= 1) then
        error('The Datas argument of function DatasToCSVFile must be matrix of real');
    end
    if (type(Rewrite) ~= 4) || (size(Rewrite)(1) ~= 1) then
        error('The Rewrite argument of function DatasToCSVFile must be booling scalar')
    end
    if (type(CSVFileName) ~= 10) || (size(CSVFileName,'*') > 1) then
        error('The CSVFileName argument of function DatasToCSVFile must be scalar string');
    end
    if (~isempty(CSVFileSep)) &&..
       ((type(CSVFileSep) ~= 10) || (size(CSVFileSep,'*') > 1)) then
        error('The CSVFileSep argument of function DatasToCSVFile must be scalar string');
    end
    if (~isempty(CSVFileDec)) &&..
       ((type(CSVFileDec) ~= 10) || (size(CSVFileDec,'*') > 1)) then
        error('The CSVFileDec argument of function DatasToCSVFile must be scalar string');
    end
    if (~isempty(CSVFileSep)) && (~isempty(CSVFileDec)) &&..
       (CSVFileSep == CSVFileDec) then
        error('The CSVFileSep and CSVFileDec arguments or function DatasToCSVFile must be not equal');
    end
    if ~isempty(DatasHeaders) && ((size(DatasHeaders)(1) ~= 1) ||..
       (type(DatasHeaders) ~= 1) && (type(DatasHeaders) ~= 10)) then
        error('The DatasHeaders argument of function DatasToCSVFile must be 1xM of string or integer');
    end
    
    //Формируем данные для сохранения в файл
    if Rewrite then
        datasCSV = DatasToCSV(Datas,DatasHeaders);//Формируем данные с заголовком в csv-формате
    else
        [datas,..
         datasHeaders]=CSVFromFileToDatas((type(DatasHeaders) == 10),..
                                          CSVFileName,CSVFileSep,..
                                          CSVFileDec,%t);//Считываем данные с заголовком
        datas = AddDatas(datas,Datas,datasHeaders,DatasHeaders,'r',%f);
        datasCSV = DatasToCSV(datas,datasHeaders);//Добавляем данные
    end
    
    //Сохраняем данные в файл
    datasCSV = strsubst(datasCSV,'.',CSVFileDec);//Задаем нужный десятичный разделитель
    write_csv(datasCSV,CSVFileName,CSVFileSep,CSVFileDec);
endfunction
