//Разделение данных на входные и выходные данные
function [inputData,..//Входные данные
          outputData,..//Выходные данные
          inputHeader,..//Заголовки (или индексы в случае без заголовков) входных данных
          outputHeader..//заголовки (или индексы в случае без заголовков) выходных данных
          ]=InputOutputDataSplit(Header,..//Заголовок таблицы данных (еще не разделенных)
                                 Datas,..//Данные (отдельно от заголовка, не разделенные)
                                 inputHeader,..//Заголовок входных данных
                                 outputHeader..//Заголовок выходных данных
                                 )
    //Проверяем входные данные
    nArg = argn(2);//Число аргументов
    if nArg < 3 then
        error('Function InputOutputDataSplit takes 3 or 4 arguments');
    end
    if nArg == 3 then
        outputHeader = inputHeader;
        inputHeader = Datas;
        Datas = Header;
        Header = [];
    end
    if (~isempty(Header)) && (type(Header) ~= 10) then
        error('The argument Header of function InputOutputDataSplit must be string');
    end
    if isempty(Datas) then
        error('The argument Datas of function InputOutputDataSplit must not be empty');
    end
    if type(Datas) ~= 1 then
        error('The argument Datas of function InputOutputDataSplit must be real');
    end
    if isempty(Header) then
        if isempty(inputHeader) || (type(inputHeader) ~= 1) then
            error('The argument inputHeader of function InputOutputDataSplit must be integer');
        end
        if isempty(outputHeader) || (type(outputHeader) ~= 1) then
            error('The argument outputHeader of function InputOutputDataSplit must be integer');
        end
    else
        if type(inputHeader) ~= 10 then
            error('The argument inputHeader of function InputOutputDataSplit must be string');
        end
        if type(outputHeader) ~= 10 then
            error('The argument outputHeader of function InputOutputDataSplit must be string');
        end
    end
    
    //Получаем входные и выходные данные
    [inputData,inputHeader]=SelectionDatas(Header,inputHeader,Datas);//Входные данные
    [outputData,outputHeader]=SelectionDatas(Header,outputHeader,Datas);//Выходные данные
endfunction
