//Разделение данных на входные и выходные данные
function [selectionDatas,..//Выделенные данные
          selectionDatasHeader..//Заголовок выделенных данных
          ]=SelectionDatas(Header,..//Заголовок таблицы данных (еще не разделенных)
                           selectionDatasHeader,..//Заголовок выделенных данных
                           Datas..//Данные (отдельно от заголовка, не разделенные)
                           )
    //Проверяем входные данные
    nArg = argn(2);//Число аргументов
    if nArg < 2 then
        error('Function SelectionDatas takes 2 or 3 arguments');
    end
    if nArg == 2 then
        Datas = selectionDatasHeader;
        selectionDatasHeader = Header;
        Header = [];
    end
    if isempty(Header) then
        if type(selectionDatasHeader) ~= 1 then
            error('The selectionDatasHeader argument of function SelectionDatas must be matrix of integer');
        end
    else
        if type(Header) ~= 10 then
            error('The Header argument of function SelectionDatas must be matrix of string');
        end
        if (~isempty(selectionDatasHeader)) &&..
           (type(selectionDatasHeader) ~= 10) then
            error('The selectionDatasHeader argument of function SelectionDatas must be matrix of string');
        end
    end
    if isempty(Datas) then
        error('The Datas argument of function SelectionDatas must not be empty');
    end
    if type(Datas) ~= 1 then
        error('The Datas argument of function SelectionDatas must be matrix of real');
    end
    
    //Получаем индексы выделенных данных
    if ~isempty(Header) then
        [nData,selectionDataIndexes] = members(selectionDatasHeader,Header);//Получаем индексы
        clear nData;//Чистим память
        selectionDatasHeader(~selectionDataIndexes) = [];//Удаляем заголовки несуществующих данных
        selectionDataIndexes(~selectionDataIndexes) = [];//Удаляем индексы несуществующих данных
    else
        maxDataIndex = size(Datas)(2);//Максимальный индекс данных
        selectionDatasHeader(selectionDatasHeader > maxDataIndex) = [];//Удаляем индексы несуществующих данных
        selectionDataIndexes = selectionDatasHeader;//Индексы данных
    end
    
    //Получаем выделенные данные
    selectionDatas = Datas(:,selectionDataIndexes);
endfunction
