[a,path] = libraryinfo('io_data_integrationlib');
clear a;
path = part(path,1:(length(path) - length('macros'))) + 'testCSV' + filesep();//Путь к csv-файлам

//Данные для тестирования
DatasHeaders = ['A1','T1','A2','D3','B2'];//Заголовки данных
Datas = rand(21, 5);//Данные
CSVFileName = path + 'rdatas21.csv';
datasCSV = [DatasHeaders;string(Datas)];//Данные в формате CSV
datasCSV = strsubst(datasCSV,'.',',');//Заменяем десятичную точку на десятичную запятую

//Сохраняем данные в формате csv в файл
write_csv(datasCSV,CSVFileName,'o');

//Запускаем функцию
[datas,..//Данные
 datasHeaders..//Заголовки данных
 ]=CSVFromFileToDatas(%t,..//Заголовки входных данных
                      CSVFileName,..//Имя csv-файла
                      "o",..//Разделитель
                      ",",..//Десятичный разделитель
                      %t..//Парсим
                      );

//Проверяем полученный результат
assert_checktrue(abs(datas - Datas) < 1E-7);
assert_checkequal(DatasHeaders,datasHeaders);

//Запускаем функцию
[datas,..//Данные
 datasHeaders..//Заголовки данных
 ]=CSVFromFileToDatas(%t,..//Заголовки входных данных
                      CSVFileName,..//Имя csv-файла
                      "o",..//Разделитель
                      ",",..//Десятичный разделитель
                      %f..//Парсим
                      );

//Проверяем полученный результат
assert_checkequal(string(evstr(datas)),string(Datas));
assert_checkequal(DatasHeaders,datasHeaders);

clear;
