//Данные для тестирования
Datas = rand(51, 9);//Данные
isVectorized = [%t,%f,%f,%t];//Все функции векторизованы

//Функции для тестирования
function [y]=Fun1(x)
    y = 0.9*x.^4 + 5.7*x.^2 + 6.1*log(abs(x) + 1.0);
endfunction
function [y]=Fun2(x)
    function y=F(t)//Функция правой части
        y = tan(t) + t - 5.1*x(2)^2 - 0.111*x(3)^2 - x(1);
    endfunction
    y = fsolve(0.0,F);
endfunction
function [y]=Fun3(x)
    function y=F1(t)//Функция правой части
        y = tan(t) + t - 8.1*x(1)^2 - 0.171*x(2)^2;
    endfunction
    function y=F2(t)//Функция правой части
        y = t^3 + t - 2.1*x(1)^2 - 0.471*x(2)^2;
    endfunction
    y = [fsolve(0.0,F1),fsolve(0.0,F2)];
endfunction
function [y]=Fun4(x)
    y = 5.1*sum(x.^4)*x.^3 + 3.51;
endfunction
Functions = cell(1, 4);//Список функций для тестирования
Functions{1} = Fun1;
Functions{2} = Fun2;
Functions{3} = Fun3;
Functions{4} = Fun4;
argumentsNames = cell(1, 4);//Имена аргументов
argumentsNames{1} = [1, 3, 5];
argumentsNames{2} = [2, 4, 7];
argumentsNames{3} = [9, 8];
argumentsNames{4} = [6, 7, 5, 2];
rezultsNames = cell(1, 4);
rezultsNames{1} = [];
rezultsNames{2} = [];
rezultsNames{3} = [];
rezultsNames{4} = [];

//Тестовый результат
rFun2 = [];
rFun3 = [];
for ind=1:51
    rFun2 = [rFun2;Fun2(Datas(ind,[2, 4, 7]))];
    rFun3 = [rFun3;Fun3(Datas(ind,[9, 8]))];
end
eRezults = [Fun1(Datas(:,[1, 3, 5])),..
            rFun2,rFun3,..
            Fun4(Datas(:,[6, 7, 5, 2]))];
errRezults = rand(eRezults);//Ошибки
eeRezults = eRezults + errRezults;
eeeRezults = eeRezults;
errRezults = abs(errRezults);//Ошибки
merrRezults = mean(errRezults,'r');
maerrRezults = max(errRezults,'r');

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     [],..//Заголовки выходных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(isempty(outputDatasHeaders));
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMax - maerrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     [],..//Заголовки выходных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(isempty(outputDatasHeaders));
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     [],..//Заголовки выходных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(isempty(outputDatasHeaders));
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(isempty(outputDatasHeaders));
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMax - maerrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(isempty(outputDatasHeaders));
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(isempty(outputDatasHeaders));
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(isempty(outputDatasHeaders));
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMax - maerrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(isempty(outputDatasHeaders));
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(isempty(outputDatasHeaders));
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

clear;
