//Данные для тестирования
DatasHeadersI = ['Q1','P1','Q2','Q3','P2','Q4','P5'];//Заголовки входных данных
DatasHeadersO = ['eQ3','eP5','eP1','eQ2','eQ1','eP2','eQ4','eP1w',..
                 'eQ3w'];//Заголовки выходных данных
Datas = rand(27, 7);//Данные
isVectorized = %t;//Все функции векторизованы

//Функции для тестирования
function [y]=Fun1(x)
    y = 0.3*x.^2 + 5.1*x + 6.1*sin(x) - 1.5;
endfunction
function [y]=Fun2(x)
    y = 0.3*x.^3 + 5.1*x + 6.63*cos(x) - 1.83;
endfunction
function [y]=Fun3(x)
    y = -0.3*x.^5 + 5.1*x.^3 + 6.7*cos(x).^2 + 0.51;
endfunction
Functions = cell(1, 3);//Список функций для тестирования
Functions{1} = Fun1;
Functions{2} = Fun2;
Functions{3} = Fun3;
argumentsNames = cell(1, 3);//Имена аргументов
argumentsNames{1} = ['P1','Q3'];
argumentsNames{2} = ['Q1','Q2','Q4'];
argumentsNames{3} = ['P1','P2','P5','Q3'];
rezultsNames = cell(1, 3);
rezultsNames{1} = [];
rezultsNames{2} = [];
rezultsNames{3} = [];

//Тестовый результат
eRezults = [Fun1(Datas(:,[2, 4])),..
            Fun2(Datas(:,[1, 3, 6])),..
            Fun3(Datas(:,[2, 5, 7, 4]))];
errRezults = rand(eRezults);//Ошибки
eeRezults = eRezults + errRezults;
eeeRezults = eeRezults;
eRezultsHeaders = DatasHeadersO;
errRezults = abs(errRezults);//Ошибки
errRefRezults = errRezults * 100 ./ abs(eeRezults);//Относительные ошибки
merrRefRezults = mean(errRefRezults,'r');
maerrRefRezults = max(errRefRezults,'r');

//Запускаем функцию
[сoutputDatasRefErr,..//Относительные погрешности выходных данных
 сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasRefErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasRefErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsRefErr(Datas,..//Входные данные
                        eeeRezults,..//Выходные данные
                        DatasHeadersI,..//Заголовки входных данных
                        DatasHeadersO,..//Заголовки выходных данных
                        Functions,..//Функции
                        argumentsNames,..//Имена (индексы) аргументов
                        rezultsNames,..//Имена (индексы) результатов
                        isVectorized..//Векторизованы ли функции
                        );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErr - errRefRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErrMean - merrRefRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErrMax - maerrRefRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasRefErr,..//Относительные погрешности выходных данных
 сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasRefErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasRefErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsRefErr(Datas,..//Входные данные
                        eeeRezults,..//Выходные данные
                        DatasHeadersI,..//Заголовки входных данных
                        DatasHeadersO,..//Заголовки выходных данных
                        Functions,..//Функции
                        argumentsNames,..//Имена (индексы) аргументов
                        rezultsNames..//Имена (индексы) результатов
                        );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErr - errRefRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErrMean - merrRefRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErrMax - maerrRefRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasRefErr,..//Относительные погрешности выходных данных
 сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasRefErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsRefErr(Datas,..//Входные данные
                        eeeRezults,..//Выходные данные
                        DatasHeadersI,..//Заголовки входных данных
                        DatasHeadersO,..//Заголовки выходных данных
                        Functions,..//Функции
                        argumentsNames,..//Имена (индексы) аргументов
                        rezultsNames,..//Имена (индексы) результатов
                        isVectorized..//Векторизованы ли функции
                        );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErr - errRefRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErrMean - merrRefRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasRefErr,..//Относительные погрешности выходных данных
 сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasRefErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsRefErr(Datas,..//Входные данные
                        eeeRezults,..//Выходные данные
                        DatasHeadersI,..//Заголовки входных данных
                        DatasHeadersO,..//Заголовки выходных данных
                        Functions,..//Функции
                        argumentsNames,..//Имена (индексы) аргументов
                        rezultsNames..//Имена (индексы) результатов
                        );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErr - errRefRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErrMean - merrRefRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasRefErr,..//Относительные погрешности выходных данных
 сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsRefErr(Datas,..//Входные данные
                        eeeRezults,..//Выходные данные
                        DatasHeadersI,..//Заголовки входных данных
                        DatasHeadersO,..//Заголовки выходных данных
                        Functions,..//Функции
                        argumentsNames,..//Имена (индексы) аргументов
                        rezultsNames,..//Имена (индексы) результатов
                        isVectorized..//Векторизованы ли функции
                        );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);

assert_checktrue(abs(сoutputDatasRefErr - errRefRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasRefErr,..//Относительные погрешности выходных данных
 сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsRefErr(Datas,..//Входные данные
                        eeeRezults,..//Выходные данные
                        DatasHeadersI,..//Заголовки входных данных
                        DatasHeadersO,..//Заголовки выходных данных
                        Functions,..//Функции
                        argumentsNames,..//Имена (индексы) аргументов
                        rezultsNames..//Имена (индексы) результатов
                        );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasRefErr - errRefRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

clear;
