[a,path] = libraryinfo('io_data_integrationlib');
clear a;
path = part(path,1:(length(path) - length('macros'))) + 'testCSV' + filesep();//Путь к csv-файлам

//Данные для тестирования
DatasHeaders = ['Ad1','Bw1','Ar2','C3','Yew2','A2','A3','C1','Cc5'];//Заголовки данных
Datas = rand(51, 9);//Данные
CSVFileName = path + 'wdatas5.csv';

//Запускаем функцию
datasCSV = DatasToCSVFile(Datas,..//Входные данные
                          DatasHeaders,..//Заголовки входных данных
                          %t,..//Перезаписываем файл
                          CSVFileName,..//Имя файла данных
                          ';'..//Разделистель
                          );

//Проверяем полученный результат
assert_checkequal(datasCSV,[DatasHeaders;string(Datas)]);

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName,';');
assert_checkequal(datasCSV,[DatasHeaders;string(Datas)]);

//Дописываем данные в файл
aDatasHeaders = ['Yew2','Ad1','C3','Bw1','Ar2','Cc5','A2','C1','A3'];//Заголовки данных
aDatas = rand(18, 9);//Данные

//Запускаем функцию
datasCSV = DatasToCSVFile(aDatas,..//Входные данные
                          aDatasHeaders,..//Заголовки входных данных
                          %f,..//Дозаписываем в файл
                          CSVFileName,..//Имя файла данных
                          ';'..//Разделистель
                          );

//Проверяем полученный результат
aDatas = aDatas(:,[2,4,5,3,1,7,9,8,6]);
assert_checkequal(datasCSV,[DatasHeaders;string([Datas;aDatas])]);

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName,';');
assert_checkequal(datasCSV,[DatasHeaders;string([Datas;aDatas])]);

clear;
