[a,path] = libraryinfo('io_data_integrationlib');
clear a;
path = part(path,1:(length(path) - length('macros'))) + 'testCSV' + filesep();//Путь к csv-файлам

//Данные для тестирования
DatasHeaders = ['A1','T1','A2','D3','B2'];//Заголовки данных
Datas = rand(21, 5);//Данные
CSVFileName = path + 'rwdatas3.csv';

//Запускаем функцию
datasCSV = DatasToCSVFile(Datas,..//Входные данные
                          DatasHeaders,..//Заголовки входных данных
                          %t,..//Перезаписываем файл
                          CSVFileName..//Имя файла данных
                          );

//Проверяем полученный результат
assert_checkequal(datasCSV,[DatasHeaders;string(Datas)]);

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName);
assert_checkequal(datasCSV,[DatasHeaders;string(Datas)]);

//Данные для дозапись
aDatasHeaders = ['D3','B2','A1','A2','T1'];//Заголовки данных
aDatas = rand(42, 5);//Данные

//Запускаем функцию
datasCSV = DatasToCSVFile(aDatas,..//Входные данные
                          aDatasHeaders,..//Заголовки входных данных
                          %f,..//Перезаписываем файл
                          CSVFileName..//Имя файла данных
                          );

//Проверяем полученный результат
aDatas = aDatas(:,[3,5,4,1,2]);
assert_checkequal(datasCSV,[DatasHeaders;string([Datas;aDatas])]);

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName);
assert_checkequal(datasCSV,[DatasHeaders;string([Datas;aDatas])]);

clear;
