[a,path] = libraryinfo('io_data_integrationlib');
clear a;
path = part(path,1:(length(path) - length('macros'))) + 'testCSV' + filesep();//Путь к csv-файлам

//Данные для тестирования
Datas = rand(51, 9);//Данные
CSVFileName = path + 'rwdatas14.csv';

//Запускаем функцию
datasCSV = DatasToCSVFile(Datas,..//Входные данные
                          [],..//Заголовки входных данных
                          %t,..//Перезаписываем файл
                          CSVFileName,..//Имя файла данных
                          ';',..//Разделитель
                          ','..//Десятичный разделитель
                          );

//Проверяем полученный результат
assert_checkequal(datasCSV,strsubst(string(Datas),'.',','));

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName,';');
assert_checkequal(datasCSV,strsubst(string(Datas),'.',','));

//Дописываемые данные
aDatas = rand(36, 9);//Данные

//Запускаем функцию
datasCSV = DatasToCSVFile(aDatas,..//Входные данные
                          [],..//Заголовки входных данных
                          %f,..//Дозаписываем файл
                          CSVFileName,..//Имя файла данных
                          ';',..//Разделитель
                          ','..//Десятичный разделитель
                          );

//Проверяем полученный результат
assert_checkequal(datasCSV,strsubst(string([Datas;aDatas]),'.',','));

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName,';');
assert_checkequal(datasCSV,strsubst(string([Datas;aDatas]),'.',','));

clear;
